// src/set_thread_name.cc
// This file is part of libpbe; see http://svn.chezphil.org/libpbe/
// (C) 2017 Philip Endecott

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "set_thread_name.hh"

#include <pthread.h>

#include <string>


namespace pbe {

extern void set_thread_name(const char* name)
{
  // FIXME what do we need to test to check for the availability of 
  // pthread_setname_np()?  __linux__ ??

  std::string s(name);
  
  // The maximum length accepted by pthread_setname_np() is 16 bytes including 
  // the terminating null; I don't think there is a macro for this.
  if (s.length() > 15) s.resize(15);

  pthread_setname_np(pthread_self(), s.c_str());

}


};


